diff --git a/packages/code-generator/src/utils/compositeType.ts b/packages/code-generator/src/utils/compositeType.ts
index edab55873..01b953fc3 100644
--- a/packages/code-generator/src/utils/compositeType.ts
+++ b/packages/code-generator/src/utils/compositeType.ts
@@ -1,45 +1,28 @@
 import {
   CompositeArray,
   CompositeValue,
-  ICompositeObject,
-  CompositeValueGeneratorOptions,
-  CompositeTypeContainerHandlerSet,
-  CodeGeneratorError,
-} from '../types';
-import { generateExpression, generateFunction, isJsExpression, isJsFunction } from './jsExpression';
-import { isJsSlot, generateJsSlot } from './jsSlot';
+  CompositeObject,
+  JSFunction,
+  isJSExpression,
+  isJSFunction,
+  isJSSlot,
+  JSSlot,
+} from '@ali/lowcode-types';
+import _ from 'lodash';
+
+import { IScope, CompositeValueGeneratorOptions, CodeGeneratorError } from '../types';
+import { generateExpression, generateFunction } from './jsExpression';
+import { generateJsSlot } from './jsSlot';
 import { isValidIdentifier } from './validate';
 import { camelize } from './common';
+import { executeFunctionStack } from './aopHelper';
 
-const defaultContainerHandlers: CompositeTypeContainerHandlerSet = {
-  default: (v) => v,
-  string: (v) => `'${v}'`,
-};
-
-function generateArray(value: CompositeArray, options: CompositeValueGeneratorOptions = {}): string {
-  const body = value.map((v) => generateUnknownType(v, options)).join(',');
+function generateArray(value: CompositeArray, scope: IScope, options: CompositeValueGeneratorOptions = {}): string {
+  const body = value.map((v) => generateUnknownType(v, scope, options)).join(',');
   return `[${body}]`;
 }
 
-function generateObject(value: ICompositeObject, options: CompositeValueGeneratorOptions = {}): string {
-  if (isJsExpression(value)) {
-    if (options.handlers && options.handlers.expression) {
-      return options.handlers.expression(value);
-    }
-    return generateExpression(value);
-  }
-
-  if (isJsFunction(value)) {
-    return generateFunction(value, { isArrow: true });
-  }
-
-  if (isJsSlot(value)) {
-    if (options.nodeGenerator) {
-      return generateJsSlot(value, options.nodeGenerator);
-    }
-    throw new CodeGeneratorError("Can't find Node Generator");
-  }
-
+function generateObject(value: CompositeObject, scope: IScope, options: CompositeValueGeneratorOptions = {}): string {
   const body = Object.keys(value)
     .map((key) => {
       let propName = key;
@@ -59,7 +42,7 @@ function generateObject(value: ICompositeObject, options: CompositeValueGenerato
           throw new CodeGeneratorError(`Propname: ${key} is not a valid identifier.`);
         }
       }
-      const v = generateUnknownType(value[key], options);
+      const v = generateUnknownType(value[key], scope, options);
       return `${propName}: ${v}`;
     })
     .join(',\n');
@@ -67,40 +50,108 @@ function generateObject(value: ICompositeObject, options: CompositeValueGenerato
   return `{${body}}`;
 }
 
-export function generateUnknownType(value: CompositeValue, options: CompositeValueGeneratorOptions = {}): string {
-  if (Array.isArray(value)) {
-    if (options.handlers && options.handlers.array) {
-      return options.handlers.array(value);
-    }
-    return generateArray(value as CompositeArray, options);
-  } else if (typeof value === 'object') {
-    if (options.handlers && options.handlers.object) {
-      return options.handlers.object(value);
-    }
-    return generateObject(value as ICompositeObject, options);
-  } else if (typeof value === 'string') {
-    if (options.handlers && options.handlers.string) {
-      return options.handlers.string(value);
-    }
-    return `'${value}'`;
-  } else if (typeof value === 'number' && options.handlers && options.handlers.number) {
-    return options.handlers.number(value);
-  } else if (typeof value === 'boolean' && options.handlers && options.handlers.boolean) {
-    return options.handlers.boolean(value);
-  }
-  return `${value}`;
+function generateString(value: string): string {
+  return `'${value}'`;
 }
 
-export function generateCompositeType(value: CompositeValue, options: CompositeValueGeneratorOptions = {}): string {
-  const result = generateUnknownType(value, options);
-  const containerHandlers = {
-    ...defaultContainerHandlers,
-    ...(options.containerHandlers || {}),
-  };
-
-  const isStringType = result.substr(0, 1) === "'" && result.substr(-1, 1) === "'";
-  if (isStringType) {
-    return (containerHandlers.string && containerHandlers.string(result.substring(1, result.length - 1))) || '';
-  }
-  return (containerHandlers.default && containerHandlers.default(result)) || '';
+function generateNumber(value: number): string {
+  return String(value);
+}
+
+function generateBool(value: boolean): string {
+  return value ? 'true' : 'false';
+}
+
+function genFunction(value: JSFunction): string {
+  return generateFunction(value, { isArrow: true });
+}
+
+function genJsSlot(value: JSSlot, scope: IScope, options: CompositeValueGeneratorOptions = {}) {
+  if (options.nodeGenerator) {
+    return generateJsSlot(value, scope, options.nodeGenerator);
+  }
+  return '';
+}
+
+function generateUnknownType(
+  value: CompositeValue,
+  scope: IScope,
+  options: CompositeValueGeneratorOptions = {},
+): string {
+  if (_.isUndefined(value)) {
+    return 'undefined';
+  }
+
+  if (_.isNull(value)) {
+    return 'null';
+  }
+
+  if (_.isArray(value)) {
+    if (options.handlers?.array) {
+      return executeFunctionStack(value, scope, options.handlers.array, generateArray, options);
+    }
+    return generateArray(value, scope, options);
+  }
+
+  if (isJSExpression(value)) {
+    if (options.handlers?.expression) {
+      return executeFunctionStack(value, scope, options.handlers.expression, generateExpression, options);
+    }
+    return generateExpression(value);
+  }
+
+  if (isJSFunction(value)) {
+    if (options.handlers?.function) {
+      return executeFunctionStack(value, scope, options.handlers.function, genFunction, options);
+    }
+    return genFunction(value);
+  }
+
+  if (isJSSlot(value)) {
+    if (options.handlers?.slot) {
+      return executeFunctionStack(value, scope, options.handlers.slot, genJsSlot, options);
+    }
+    return genJsSlot(value, scope, options);
+  }
+
+  if (_.isObject(value)) {
+    if (options.handlers?.object) {
+      return executeFunctionStack(value, scope, options.handlers.object, generateObject, options);
+    }
+    return generateObject(value as CompositeObject, scope, options);
+  }
+
+  if (_.isString(value)) {
+    if (options.handlers?.string) {
+      return executeFunctionStack(value, scope, options.handlers.string, generateString, options);
+    }
+    return generateString(value);
+  }
+
+  if (_.isNumber(value)) {
+    if (options.handlers?.number) {
+      return executeFunctionStack(value, scope, options.handlers.number, generateNumber, options);
+    }
+    return generateNumber(value);
+  }
+
+  if (_.isBoolean(value)) {
+    if (options.handlers?.boolean) {
+      return executeFunctionStack(value, scope, options.handlers.boolean, generateBool, options);
+    }
+    return generateBool(value);
+  }
+
+  throw new CodeGeneratorError('Meet unknown composite value type');
+}
+
+// 这一层曾经是对产出做最外层包装的，但其实包装逻辑不应该属于这一层
+// 这一层先不去掉，做冗余，方便后续重构
+export function generateCompositeType(
+  value: CompositeValue,
+  scope: IScope,
+  options: CompositeValueGeneratorOptions = {},
+): string {
+  const result = generateUnknownType(value, scope, options);
+  return result;
 }
diff --git a/packages/code-generator/src/utils/expressionParser.ts b/packages/code-generator/src/utils/expressionParser.ts
new file mode 100644
index 000000000..cc952060b
--- /dev/null
+++ b/packages/code-generator/src/utils/expressionParser.ts
@@ -0,0 +1,243 @@
+import * as parser from '@babel/parser';
+import generate from '@babel/generator';
+import traverse, { NodePath } from '@babel/traverse';
+import * as t from '@babel/types';
+import { isIdentifier, Node } from '@babel/types';
+
+import { OrderedSet } from './OrderedSet';
+
+export class ParseError extends Error {
+  constructor(expr: string | t.Expression) {
+    super(`Failed to parse expression "${typeof expr === 'string' ? expr : generate(expr)}"`);
+    Object.setPrototypeOf(this, new.target.prototype);
+  }
+}
+
+const MAYBE_EXPRESSIONS: {
+  [k in Node['type']]?: {
+    // fields: Array<keyof (Node & { type: k })>
+    fields: string[] | ((node: Node) => string[]);
+  };
+} = {
+  ArrayExpression: { fields: ['elements'] },
+  AssignmentExpression: { fields: ['left', 'right'] },
+  BinaryExpression: { fields: ['left', 'right'] },
+  CallExpression: { fields: ['arguments', 'callee'] },
+  ConditionalExpression: { fields: ['test', 'consequent', 'alternate'] },
+  DoWhileStatement: { fields: ['test'] },
+  ExpressionStatement: { fields: ['expression'] },
+  ForInStatement: { fields: ['right'] },
+  ForStatement: { fields: ['init', 'test', 'update'] },
+  IfStatement: { fields: ['test'] },
+  LogicalExpression: { fields: ['left', 'right'] },
+  MemberExpression: {
+    fields: (node) => { return (node.type === 'MemberExpression' && node.computed) ? ['object', 'property'] : ['object']; },
+  },
+  NewExpression: { fields: ['callee', 'arguments'] },
+  ObjectMethod: {
+    fields: (node) => { return (node.type === 'ObjectMethod' && node.computed) ? ['key'] : []; },
+  },
+  ObjectProperty: {
+    fields: (node) => { return (node.type === 'ObjectProperty' && node.computed) ? ['key', 'value'] : ['value']; },
+  },
+  ReturnStatement: { fields: ['argument'] },
+  SequenceExpression: { fields: ['expressions'] },
+  ParenthesizedExpression: { fields: ['expression'] },
+  SwitchCase: { fields: ['test'] },
+  SwitchStatement: { fields: ['discriminant'] },
+  ThrowStatement: { fields: ['argument'] },
+  UnaryExpression: { fields: ['argument'] },
+  UpdateExpression: { fields: ['argument'] },
+  VariableDeclarator: { fields: ['init'] },
+  WhileStatement: { fields: ['test'] },
+  WithStatement: { fields: ['object'] },
+  AssignmentPattern: { fields: ['right'] },
+  ArrowFunctionExpression: { fields: ['body'] },
+  ClassExpression: { fields: ['superClass'] },
+  ClassDeclaration: { fields: ['superClass'] },
+  ExportDefaultDeclaration: { fields: ['declaration'] },
+  ForOfStatement: { fields: ['right'] },
+  ClassMethod: { fields: (node) => { return (node.type === 'ClassMethod' && node.computed) ? ['key'] : []; } },
+  SpreadElement: { fields: ['argument'] },
+  TaggedTemplateExpression: { fields: ['tag'] },
+  TemplateLiteral: { fields: ['expressions'] },
+  YieldExpression: { fields: ['argument'] },
+  AwaitExpression: { fields: ['argument'] },
+  OptionalMemberExpression: {
+    fields: (node) => { return (node.type === 'OptionalMemberExpression' && node.computed) ? ['object', 'property'] : ['object']; },
+  },
+  OptionalCallExpression: { fields: ['callee', 'arguments'] },
+  JSXSpreadAttribute: { fields: ['argument'] },
+  BindExpression: { fields: ['object', 'callee'] },
+  ClassProperty: { fields: (node) => { return (node.type === 'ClassProperty' && node.computed) ? ['key', 'value'] : ['value']; } },
+  PipelineTopicExpression: { fields: ['expression'] },
+  PipelineBareFunction: { fields: ['callee'] },
+  ClassPrivateProperty: { fields: ['value'] },
+  Decorator: { fields: ['expression'] },
+  TupleExpression: { fields: ['elements'] },
+  TSDeclareMethod: { fields: (node) => { return (node.type === 'TSDeclareMethod' && node.computed) ? ['key'] : []; } },
+  TSPropertySignature: {
+    fields: (node) => { return (node.type === 'TSPropertySignature' && node.computed) ? ['key', 'initializer'] : ['initializer']; },
+  },
+
+  TSMethodSignature: {
+    fields: (node) => { return (node.type === 'TSMethodSignature' && node.computed) ? ['key'] : []; },
+  },
+  TSAsExpression: { fields: ['expression'] },
+  TSTypeAssertion: { fields: ['expression'] },
+  TSEnumDeclaration: { fields: ['initializer'] },
+  TSEnumMember: { fields: ['initializer'] },
+  TSNonNullExpression: { fields: ['expression'] },
+  TSExportAssignment: { fields: ['expression'] },
+};
+
+export type ParseExpressionGetGlobalVariablesOptions = { filter?: (varName: string) => boolean };
+
+const CROSS_THIS_SCOPE_TYPE_NODE: {
+  [k in Node['type']]?: boolean;
+} = {
+  ArrowFunctionExpression: false, // 箭头函数不跨越 this 的 scope
+  FunctionExpression: true,
+  FunctionDeclaration: true,
+  // FunctionTypeAnnotation: false, // 这是 TS 定义
+  // FunctionTypeParam: false, // 这是 TS 定义
+  ClassDeclaration: true,
+  ClassExpression: true,
+  ClassBody: true,
+  ClassImplements: true,
+  ClassMethod: true,
+  ClassPrivateMethod: true,
+  ClassProperty: true,
+  ClassPrivateProperty: true,
+  DeclareClass: true,
+};
+
+export function parseExpressionGetGlobalVariables(
+  expr: string | null | undefined,
+  { filter = () => true }: ParseExpressionGetGlobalVariablesOptions = {},
+): string[] {
+  if (!expr) {
+    return [];
+  }
+
+  try {
+    const undeclaredVars = new OrderedSet<string>();
+
+    const ast = parser.parse(`!(${expr});`);
+
+    const addUndeclaredIdentifierIfNeeded =
+      (x: Record<string, unknown> | null | undefined, path: NodePath<Node>) => {
+        if (isIdentifier(x) && !path.scope.hasBinding(x.name)) {
+          undeclaredVars.add(x.name);
+        }
+      };
+
+    traverse(ast, {
+      enter(path) {
+        const node = path.node;
+        const expressionFields = MAYBE_EXPRESSIONS[node.type]?.fields;
+        if (expressionFields) {
+          (typeof expressionFields === 'function' ? expressionFields(node) : expressionFields).forEach((fieldName) => {
+            const fieldValue = node[fieldName as keyof typeof node];
+            if (typeof fieldValue === 'object') {
+              if (Array.isArray(fieldValue)) {
+                fieldValue.forEach((item) => {
+                  addUndeclaredIdentifierIfNeeded(item, path);
+                });
+              } else {
+                addUndeclaredIdentifierIfNeeded(fieldValue, path);
+              }
+            }
+          });
+        }
+      },
+    });
+
+    return undeclaredVars.toArray().filter(filter);
+  } catch (e) {
+    throw new ParseError(expr);
+  }
+}
+
+export function parseExpressionConvertThis2Context(
+  expr: string | t.Expression,
+  contextName = '__$$context',
+  localVariables: string[] = [],
+): string {
+  if (!expr) {
+    return expr;
+  }
+
+  try {
+    const exprAst = typeof expr === 'string' ? parser.parseExpression(expr) : expr;
+    const exprWrapAst = t.expressionStatement(exprAst);
+    const fileAst = t.file(t.program([exprWrapAst]));
+
+    const localVariablesSet = new Set(localVariables);
+
+    let thisScopeLevel = CROSS_THIS_SCOPE_TYPE_NODE[exprAst.type] ? -1 : 0;
+    traverse(fileAst, {
+      enter(path) {
+        if (CROSS_THIS_SCOPE_TYPE_NODE[path.node.type]) {
+          thisScopeLevel++;
+        }
+      },
+      exit(path) {
+        if (CROSS_THIS_SCOPE_TYPE_NODE[path.node.type]) {
+          thisScopeLevel--;
+        }
+      },
+      MemberExpression(path) {
+        if (!path.isMemberExpression()) {
+          return;
+        }
+
+        const obj = path.get('object');
+        if (!obj.isThisExpression()) {
+          return;
+        }
+
+        // 处理局部变量
+        if (!path.node.computed) {
+          const prop = path.get('property');
+          if (prop.isIdentifier() && localVariablesSet.has(prop.node.name)) {
+            path.replaceWith(t.identifier(prop.node.name));
+            return;
+          }
+        }
+
+        // 替换 this (只在顶层替换)
+        if (thisScopeLevel <= 0) {
+          obj.replaceWith(t.identifier(contextName));
+        }
+      },
+      ThisExpression(path) {
+        if (!path.isThisExpression()) {
+          return;
+        }
+
+        // MemberExpression 中的 this.xxx 已经处理过了
+        if (path.parent.type === 'MemberExpression') {
+          return;
+        }
+
+        if (thisScopeLevel <= 0) {
+          path.replaceWith(t.identifier(contextName));
+        }
+      },
+    });
+
+    const { code } = generate(exprWrapAst.expression, { sourceMaps: false });
+    return code;
+  } catch (e) {
+    throw new ParseError(expr);
+  }
+}
+
+export function parseExpression(expr: string) {
+  try {
+    return parser.parseExpression(expr);
+  } catch (e) {
+    throw new ParseError(expr);
+  }
+}
diff --git a/packages/code-generator/src/utils/jsExpression.ts b/packages/code-generator/src/utils/jsExpression.ts
index d975228ee..d30e27141 100644
--- a/packages/code-generator/src/utils/jsExpression.ts
+++ b/packages/code-generator/src/utils/jsExpression.ts
@@ -1,4 +1,5 @@
-import { CodeGeneratorError, IJSExpression, IJSFunction } from '../types';
+import { JSExpression, JSFunction, isJSExpression, isJSFunction } from '@ali/lowcode-types';
+import { CodeGeneratorError } from '../types';
 
 export function transformFuncExpr2MethodMember(methodName: string, functionBody: string): string {
   const args = getFuncExprArguments(functionBody);
@@ -23,8 +24,6 @@ export function getFuncExprBody(functionBody: string) {
   const start = functionBody.indexOf('{');
   const end = functionBody.lastIndexOf('}');
 
-  // test(functionBody);
-
   if (start < 0 || end < 0 || end < start) {
     throw new CodeGeneratorError('JSExpression has no valid body.');
   }
@@ -40,21 +39,13 @@ export function getArrowFunction(functionBody: string) {
   return `(${args}) => { ${body} }`;
 }
 
-export function isJsExpression(value: unknown): boolean {
-  return value && typeof value === 'object' && (value as IJSExpression).type === 'JSExpression';
-}
-
-export function isJsFunction(value: unknown): boolean {
-  return value && typeof value === 'object' && (value as IJSFunction).type === 'JSFunction';
-}
-
 export function isJsCode(value: unknown): boolean {
-  return isJsExpression(value) || isJsFunction(value);
+  return isJSExpression(value) || isJSFunction(value);
 }
 
 export function generateExpression(value: any): string {
-  if (isJsExpression(value)) {
-    return (value as IJSExpression).value || 'null';
+  if (isJSExpression(value)) {
+    return (value as JSExpression).value || 'null';
   }
 
   throw new CodeGeneratorError('Not a JSExpression');
@@ -75,7 +66,7 @@ export function generateFunction(
   },
 ) {
   if (isJsCode(value)) {
-    const functionCfg = value as IJSFunction;
+    const functionCfg = value as JSFunction;
     if (config.isMember) {
       return transformFuncExpr2MethodMember(config.name || '', functionCfg.value);
     }
diff --git a/packages/code-generator/src/utils/jsSlot.ts b/packages/code-generator/src/utils/jsSlot.ts
index 13f40eef6..e47136ed2 100644
--- a/packages/code-generator/src/utils/jsSlot.ts
+++ b/packages/code-generator/src/utils/jsSlot.ts
@@ -1,20 +1,34 @@
-import { CodeGeneratorError, NodeGenerator, IJSSlot } from '../types';
+import { JSSlot, isJSSlot } from '@ali/lowcode-types';
+import { CodeGeneratorError, NodeGenerator, IScope } from '../types';
 
-export function isJsSlot(value: unknown): boolean {
-  return value && typeof value === 'object' && (value as IJSSlot).type === 'JSSlot';
+function generateSingleLineComment(commentText: string): string {
+  return (
+    `/* ${
+      commentText
+        .split('\n')
+        .join(' ')
+        .replace(/\*\//g, '*-/')
+    }*/`
+  );
 }
 
-export function generateJsSlot(value: any, generator: NodeGenerator): string {
-  if (isJsSlot(value)) {
-    const slotCfg = value as IJSSlot;
-    if (!slotCfg.value) {
-      return 'null';
+export function generateJsSlot(slot: any, scope: IScope, generator: NodeGenerator<string>): string {
+  if (isJSSlot(slot)) {
+    const { title, params, value } = slot as JSSlot;
+    if (params) {
+      return [
+        title && generateSingleLineComment(title),
+        '(',
+        ...(params || []),
+        ') => (',
+        !value ? 'null' : generator(value, scope),
+        ')',
+      ]
+        .filter(Boolean)
+        .join('');
     }
-    const results = slotCfg.value.map((n) => generator(n));
-    if (results.length === 1) {
-      return results[0];
-    }
-    return `[${results.join(',')}]`;
+
+    return !value ? 'null' : generator(value, scope);
   }
 
   throw new CodeGeneratorError('Not a JSSlot');
